<html><head>
<style type="text/css">
html,body {
	font:normal 0.9em arial,helvetica;
}
#log {
	width:600px;
	height:300px;
	border:1px solid #7F9DB9;
	overflow:auto;
}
#msg {
	width:200px;
}
</style>

<script type="text/javascript" >
// Always use strict mode prevents bad practices
'use strict';

var newarray = [];


function myDeleteFunction() {
    document.getElementById("newmsg").deleteRow(0);
}

function loadTable(tableId, fields, data){
  var rows = '';
  $.each(data, function(index, item) {
    var row = '<tr>';
    $.each(fields, function(indec,field){
      row += '<td>' + item[field+''] + '</td>';
    });
    rows += row +'<tr>';
  });
  $('#' + tableId).html(rows);

}
</script>



<script type="text/javascript">
var socket;

function init() {
	var host = "ws://192.168.1.3:9001/"; // SET THIS TO YOUR SERVER
	try {
		// start up the web socket
		socket = new WebSocket(host);
		log('WebSocket - status '+socket.readyState);
		socket.onopen    = function(msg) {
							  console.log("Welcome - status "+this.readyState);
							  document.getElementById('status').innerHTML = "Status "+this.readyState;
						   };

		// We process all incomming messages in this function
		socket.onmessage = function(msg)
		{
			console.log(msg.data);
			// Take the inbound messge and turn back into array
			var JSONObject = JSON.parse(msg.data);
			// the starting message type will always be an event
			switch (JSONObject["event"])
      {
		  	case 'new':
					// Process new messages
					// we will add to the new messages table
		      			var table = document.getElementById("newmsg");
    	    				var row = table.insertRow(1);
          				row.id = JSONObject["id"];

					// each row has an onclick event to create a table
					row.addEventListener('click', function (){
						//$('sendto').value = JSONObject["number"];

						// drop current messages table
						//var element = document.getElementById("messages");
						//element.parentNode.removeChild(element);

						// create a new table
						$('message-div').innerHTML += '<table id="messages" border="1"><tr><th style="align: left;">Status</th><th>Message</th><th style="align: right;">Date</th></tr></table>';

						// query all messages for the number you clicked on
						var msg = JSON.stringify({ "event":"findall", "number": JSONObject["number"] });
					  	socket.send(msg);
						
						document.getElementById('sendto').value = JSONObject["number"];
						document.getElementById('sendto').disabled = true;
					}, false);

          				var cell0 = row.insertCell(0);
          				var cell1 = row.insertCell(1);
          				var cell2 = row.insertCell(2);

          				cell0.innerHTML = "New";
          				if (JSONObject["name"] != null) cell1.innerHTML = JSONObject["name"];
          				else cell1.innerHTML = JSONObject["number"];
          				cell2.innerHTML = JSONObject["date"];
					break;

        			case 'sent':
					console.log(msg.data);
				  	var table = document.getElementById("messages");
          				var row = table.insertRow(1);
          				row.id = JSONObject["id"];
					$('message').value = '';

          				var cell0 = row.insertCell(0);
          				var cell1 = row.insertCell(1);
          				var cell2 = row.insertCell(2);

					cell0.innerHTML = JSONObject['status'];
					cell1.innerHTML = JSONObject["message"];
					cell2.innerHTML = JSONObject["date"];
          				break;

				case 'findall_history':
					var table = document.getElementById("messages");
					var row = table.insertRow(1);
					row.id = JSONObject["id"];

					var cell0 = row.insertCell(0);
					var cell1 = row.insertCell(1);
					var cell2 = row.insertCell(2);

					cell0.innerHTML = JSONObject['status'];
					cell1.innerHTML = JSONObject["message"];
					cell2.innerHTML = JSONObject["date"];
					break;

				case 'read':
					var table = document.getElementById('newmsg');
					var rowIndex = document.getElementById(JSONObject['id']).rowIndex;
					table.deleteRow(rowIndex);

					document.getElementById("messages").rows.namedItem(JSONObject['id']).cells[0].innerHTML = JSONObject['status'];
					break;
		
				case 'status':
					document.getElementById('status').innerHTML = "<font color=\"green\">"+JSONObject['message']+"</font>";
					break;

		  default:
		    log("Unknown : "+ msg.data);
		  break;

		  };
		};
		socket.onclose   = function(msg) {
			log("Disconnected - status "+this.readyState);
			document.getElementById('status').innerHTML = "<font color=\"red\">Disconnected</font>";
		};
	}
	catch(ex){ log(ex);}
	//$("username").focus();
}

function quit(){
	if (socket != null) {
		log("Goodbye!");
		socket.close();
		socket=null;
	}
}

function sendtext() {
	var message = document.getElementById('message').value;
	var sendto = document.getElementById('sendto').value;
	var msg = JSON.stringify({ "event":"sendtext", "number":sendto, "msg":message });
	socket.send(msg);
	document.getElementById('message').value = "";
	read();
}

function read() {
	// drop current messages table
	var element = document.getElementById("messages");
	element.parentNode.removeChild(element);
	
	document.getElementById('sendto').disabled = false;
	var sendto = document.getElementById('sendto').value;
	var msg = JSON.stringify({ "event":"read", "number":sendto });
  	socket.send(msg);
	document.getElementById('sendto').value = "";
}

// Utilities
function $(id){ return document.getElementById(id); }
function log(msg){ console.log(msg); }

function countChars(textbox, counter, max) {
	  var count = max - document.getElementById(textbox).value.length;
	    if (count < 0) { document.getElementById(counter).innerHTML = "<span style=\"color: red;\">" + count + " Characters Left</span>"; }
	      else { document.getElementById(counter).innerHTML = count+" Characters Left"; }
}

</script>

</head>
<body onload="init()">
	<h3>Text Messaging Service</h3>
	<div id="status"><font color="red">Offline</font></div>
	</br>
<div style="width: 30%; float: left;">
	<table id="newmsg" border="1">
	  <tr>
	    <th>Status</th>
	    <th>From</th>
	    <th>Date</th>
	  </tr>
	</table>
</div>
<div id="message-div" style="width: 70%; float: right;">
	<p>Mobile Number</p>
	<input id="sendto" type="text"/>
	<p>Message to send</p>
	<textarea id="message" rows="4" cols="50" maxlength="140" onFocus="countChars('message','char_count',140)" onKeyDown="countChars('message','char_count',140)" onKeyUp="countChars('message','char_count',140)"/></textarea>
	<div id="char_count">140 Characters Left</div>
	<button onclick="sendtext()">Send</button>
	<button onClick="read()">Read All</button>
	</br>
</body>
</html>
